﻿using System;

namespace Ion.HabboHotel.Client
{
    public partial class ClientMessageHandler
    {
        /// <summary>
        /// 434 - "Fr"
        /// </summary>
        private void GetOwnRooms()
        {
            response.Initialize(451);
            response.writeInt(0);
            response.writeInt(5);
            response.writeString("");

            response.writeInt(1);
            response.writeInt(1);
            response.writeBool(false);
            response.writeString("Alex's Room");
            response.writeString("Alex");
            response.writeInt(0); // room state
            response.writeInt(1);
            response.writeInt(24);
            response.writeString("Epik room desc");
            response.writeInt(1);// Response.AppendBoolean(true); // dunno!
            response.writeBool(true); // can trade?
            response.writeInt(1337);
            response.writeInt(0);
            response.writeString("");
            string[] Tags = new string[] { "tag1", "tag2" };
            response.writeInt(Tags.Length);
            foreach (string Tag in Tags)
            {
                response.writeString(Tag);
            }

            response.writeInt(0);
            response.writeInt(0);
            response.writeInt(0);

            SendResponse();

        }

        /// <summary>
        /// 380 - "E|"
        /// </summary>
        private void SetFrontPageListening()
        {
            response.Initialize(ResponseOpcodes.NavigatorFrontPageResult); // "GB"

            response.writeInt(2); // category count

            response.writeInt(1337);
            response.writeString("Category Example 1");

            response.writeInt(9001);
            response.writeString("Category Example 2");

            response.writeInt(2);


            response.writeString("testing name");
            response.writeString("Awesome room description rite here m8");
            response.writeInt(1); // type??
            response.writeString("testing name");
            response.writeString("officialrooms_es/shoppingdeals_recroom.gif");
            response.writeInt(20); // users now

            int type = 3;
            response.writeInt(type); // public listing type

            if (type == 3) // if type is a room
            {
                response.writeString("officialrooms_es/shoppingdeals_recroom.gif");
                response.writeInt(-1);
                response.writeInt(0);
                response.writeString("hh_room_pub");
                response.writeInt(25); // max users
                response.writeInt(1001); // room id
            }

            response.writeString("another test");
            response.writeString("wow kewl!! xd");
            response.writeInt(0); // type??
            response.writeString("another test");
            response.writeString("officialrooms_defaults/hh_room_floatinggarden.png");
            response.writeInt(0);
            response.writeInt(10);
            response.writeInt(4);
            response.writeInt(227); // room id

            SendResponse();

        }

        /// <summary>
        /// 381 - "E}"
        /// </summary>
        private void GuestRoomSearch()
        {

        }

        /// <summary>
        /// 382 - "E~"
        /// </summary>
        private void GetPopularRoomTags()
        {

        }

        /// <summary>
        /// 385 - "FA"
        /// </summary>
        private void GetGuestRoom()
        {
            uint roomID = Request.PopWireduint();

            response.Initialize(ResponseOpcodes.GetGuestRoomResult);
            response.writeInt(0);
            response.AppendUInt32(roomID); // Room ID
            response.writeInt(0);
            response.writeString("Room 1"); // Room name
            response.writeString("Nillus"); // Room owner name
            response.writeInt(0); // Accesstype (0 = open, 1 = closed, 2 = password)
            response.writeInt(0); // Current visitor amount
            response.writeInt(25); // Max visitor amount
            response.writeString("Description"); // Room description
            response.writeInt(0);
            response.writeInt(0);
            response.writeInt(0);
            response.writeInt(2); // Icon ID?
            response.writeString("Category"); // Room category name
            response.writeString("tag1");
            response.writeString("tag2");
            response.writeBool(false);
            SendResponse();
        }

        /// <summary>
        /// Registers request handlers that process room Navigator queries etc.
        /// </summary>
        public void RegisterNavigator()
        {
            mRequestHandlers[380] = new RequestHandler(SetFrontPageListening);
            mRequestHandlers[434] = new RequestHandler(GetOwnRooms);
            mRequestHandlers[381] = new RequestHandler(GuestRoomSearch);
            mRequestHandlers[382] = new RequestHandler(GetPopularRoomTags);
            mRequestHandlers[385] = new RequestHandler(GetGuestRoom);
        }
    }
}
