﻿using System;

namespace Ion.HabboHotel.Client
{
    public partial class ClientMessageHandler
    {
        private void InitCrypto()
        {
            response.Initialize(ResponseOpcodes.SessionParams); // "DA"
            response.writeInt(9);
            response.writeInt(0);
            response.writeInt(0);
            response.writeInt(1);
            response.writeInt(1);
            response.writeInt(3);
            response.writeInt(0);
            response.writeInt(2);
            response.writeInt(1);
            response.writeInt(4);
            response.writeInt(0);
            response.writeInt(5);
            response.writeString("dd-MM-yyyy");
            response.writeInt(7);
            response.writeBool(false);
            response.writeInt(8);
            response.writeString("hotel-co.uk");
            response.writeInt(9);
            response.writeBool(false);
            SendResponse();

            /* WITH ENCRYPTION
            bool status = Request.PopWiredBoolean();
            string token = "02d6b0969196802df2";

            Response.Initialize(ResponseOpcodes.InitCrypto); // "DU"
            Response.AppendString(token);
            Response.AppendBoolean(status);
            SendResponse();
            */
        }

        private void SSOTicket()
        {
            // Process ticket login
            string sTicket = Request.PopFixedString();
            mSession.Login(sTicket);
        }

        private void GenerateSecretKey()
        {
            // Get the client's public key (by the token)
            string sClientKey = Request.PopFixedString();

            // Now create the server's public key (we love Diffie Hellman!)
            string sServerKey = new Random().Next(0, int.MaxValue).ToString();

            // And send the server's public key
            response.Initialize(ResponseOpcodes.SecretKey); // "@A"
            response.AppendString(sServerKey);
            SendResponse();
        }

        public void RegisterPreLogin()
        {
            mRequestHandlers[206] = new RequestHandler(InitCrypto);
            mRequestHandlers[415] = new RequestHandler(SSOTicket);
            mRequestHandlers[2002] = new RequestHandler(GenerateSecretKey);

        }
        public void UnRegisterPreLogin()
        {
            mRequestHandlers[206] = null;
            mRequestHandlers[415] = null;
            mRequestHandlers[2002] = null;
        }
    }
}
